function callback()
  print("YES!")
  return false
end

function callback2()
  print("YES2!")
  return true
end

function hut_callback(unit)
  print("HUT_ENTER: unit: " .. unit.id)
  return true
end
-- add_event_handler("blockhead", callback)

function add(a, b, c)
  return a+b+c
end

function print_plr(plr_id)
  plr = find.player(plr_id)
  print("Player " .. plr_id .. ": " .. plr.name)
  return plr
end

function print_unit(unit_id)
  unit = find.unit(nil, unit_id)
  print("Unit " .. unit_id .. ":")
  print(" |- owner: " .. unit:owner().name)
  print(" |- home: " .. unit:homecity().name)
  return unit
end

function Player:method()
  return 3
end

-- arg unpack testing.
print(add(1,2,3) == add(unpack({1,2,3})))
print("----")

-- player testing.
plr = print_plr(0)
print("----")

-- user defined method testing.
print(plr.method() == 3)
print("----")

-- unit testing.
print_unit(69);
print("----")

-- store module testing.
store.set("a", 0)
store.set("b", 2)
store.set("c", 3)
store.set("a", 1)

print(store.get("a") == 1)
print(store.get("b") == 2)
print(store.pop("c") == 3)
print(store.has_key("c") == false)
print("----")

print(callback)
print("----")

signal.connect("turn", "callback")
signal.connect("turn", "callback2")
--signal.connect("turn", nil)

---
signal.connect("hut_enter", "hut_callback")
